@echo off
echo exo2srt_eng.bat ver.1.4.0　by crayonzen [2020-08-21]
echo convert "Aviutl object file .exo" to "Subtitle file (unicode UTF-16LE) .srt"
echo To stop the processing, press Ctrl + C, but the files for processing remain.
echo For the directory where the batch file and nkf are placed, do not use spaces or symbols in the absolute path.
echo Do not use spaces or symbols in the filename and absolute path to process.
echo;

setlocal enabledelayedexpansion

for %%f in (%*) do (
  set filename=%%~nxf
)

if "%filename%" equ "" (
  set /p filename="Enter the file name (avoid spaces and special symbols):"
)
echo;
echo in _ Files to process
echo %filename%
set newfilename=%filename%.srt

echo;
echo out _ File to output (Layer number is added when layering)
echo %newfilename%

if exist %newfilename% (
 echo (Current %newfilename% will be deleted)
)

:CODE2
echo;
echo The numbers in the sequence of the output file are the serial numbers in the object reading order.
echo Therefore, if the layers are different, the numbers will be different.
echo If it is not for each layer (integration), the time may overlap, so it may not be possible to display it as it is.
echo In addition, the order of the time labels will be different in the order of loading the objects.
echo Adjust both with subtitle editing software such as Subtitle Workshop.
echo;
set /p yn="Do you want to output by layer ?(y=Yes/n=No)"
if /i "%yn%" == "n" (
   set layervar=0
   echo Does not separate layers. Will be integrated
  ) else (
  if /i "%yn%" == "y" (
   set layervar=1
   echo Separate by layer
   ) else (
   goto CODE2
  )
)

:CODE3
echo;
echo When opening with Windows Notepad, etc.
echo If you do not add a BOM, it may not be possible to judge and it may be displayed as ANSI and garbled
echo Please add BOM when converting the character code to ANSI or UTF-8 with Notepad.
echo;
set /p yn="Do you want a BOM ?(y=Yes/n=No)"
if /i "%yn%" == "n" (
   set bomvar=0
   echo No BOM
  ) else (
  if /i "%yn%" == "y" (
   set bomvar=1
   echo BOM attach
   ) else (
   goto CODE3
  )
)

echo;
pause

echo It is being processed ...
if %layervar% equ 0 (
    if exist %newfilename% del /q %newfilename%
rem  type nul > %newfilename%
 ) else (
  for /L %%n in ( 1,1,100 ) do (
    set lnum=%%n
    set filelayernum=!filename!!lnum!.srt
    if exist !filelayernum! del /q !filelayernum!
  )
)
    
type nul > temp.txt
type nul > temp2.txt
type nul > bom.txt

rem Create an empty file with UTF-16LE BOM
echo.FFFE> temp.txt
certutil -f -decodehex temp.txt bom.txt 12 > nul

set tnum=0
set elep=
set layernumlist=
set prelayernum=pre

rem new line _ unicodehex 0D000A00
rem After inserting a line feed character in the variable LF, leave two or more blank spaces. Write from the third line onwards.
set LF=^


for /f "usebackq tokens=1,2 delims==" %%a in ( "!filename!" ) do (

  set item=%%a
 if !item! equ rate (
  set ratenum=%%b
 )
 if !item! equ scale (
  set scalenum=%%b
 )
 if !item! equ start (
  set startnum=%%b
 )
 if !item! equ layer (
  set layernum=%%b
 )
 if !item! equ end (
  set endnum=%%b
 )
 if !item! equ text (
rem Number
  set /a tnum=!tnum!+1
  set elep=!tnum!!LF!

echo !tnum!

rem Time
rem echo rate=!ratenum!  scale=!scalenum!  start=!startnum! end=!endnum!

rem start time
  set /a ss=!startnum!*!scalenum!/!ratenum!
  set /a ccn=!startnum!*!scalenum!*1000/!ratenum!
  set cc2=!ccn:~-3!

rem  echo !ss!
rem  echo !ccn!
rem  echo !cc2!

  set /a ss2=!ss!%%60
  set /a mm=!ss!/60
  set /a mm2=!mm!%%60
  set /a hh2=!mm!/60
 
  if !ss2! LSS 10 (
   set ss2=0!ss2!
  )
  if !mm2! LSS 10 (
   set mm2=0!mm2!
  )
  if !hh2! LSS 10 (
   set hh2=0!hh2!
  )
  if !cc2! LSS 10 (
   set cc2=00!cc2!
  ) else (
    if !cc2! LSS 100 (
	  set cc2=0!cc2!
	)
  )
  set cc2=!cc2:~-3!
  set time1=!hh2!:!mm2!:!ss2!,!cc2!

rem end time
  set /a ss=!endnum!*!scalenum!/!ratenum!
  set /a ccn=!endnum!*!scalenum!*1000/!ratenum!
  set cc2=!ccn:~-3!

  set /a ss2=!ss!%%60
  set /a mm=!ss!/60
  set /a mm2=!mm!%%60
  set /a hh2=!mm!/60
 
  if !ss2! LSS 10 (
   set ss2=0!ss2!
  )
  if !mm2! LSS 10 (
   set mm2=0!mm2!
  )
  if !hh2! LSS 10 (
   set hh2=0!hh2!
  )
  if !cc2! LSS 10 (
   set cc2=00!cc2!
  ) else (
    if !cc2! LSS 100 (
	  set cc2=0!cc2!
	)
  )
  set cc2=!cc2:~-3!
  set time2=!hh2!:!mm2!:!ss2!,!cc2!

rem Add one frame time when the start and end are the same
   if "!time1!" == "!time2!" (
     set /a ratetime=1*!scalenum!*1000/!ratenum!
rem test ratetime 1
rem set /a ratetime=1
echo _ !tnum! Same frame Plus !ratetime! millisecond

     set /a ccn2=1!ccn2!-1000
     set /a ccn3=!cc2!*1000+!ratetime!*1000
     set /a ccn=!ccn3!/1000
     set /a cc2=!ccn:~-3!
rem echo !cc2!

  if !cc2! LSS 10 (
   set cc2=00!cc2!
  ) else (
    if !cc2! LSS 100 (
	  set cc2=0!cc2!
	)
  )
     set cc2=!cc2:~-3!
     set time2=!hh2!:!mm2!:!ss2!,!cc2!
   )

  set elep=!elep!!time1! --^> !time2!

  echo !elep!> temp.txt
 if %layervar% equ 0 (
    cmd /u /c type temp.txt >> !newfilename!
  ) else (
    if not !layernum! equ !prelayernum! (
      set layernumlist=!layernumlist!!LF!!layernum!
      set prelayernum=!layernum!
      )
    cmd /u /c type temp.txt >> !filename!!layernum!.srt
  )

rem Text
  set texthex=%%b
  set texthex2=!texthex:00000000=!
  set endsp=!texthex2:~-4!
  if !endsp! equ 0000 (
    set texthex2=!texthex2:~0,-4!
  )
rem Add a line break 0D 00 0A 00
  set texthex2=!texthex2!0D000A000D000A00
  echo !texthex2!> temp.txt
  certutil -f -decodehex temp.txt temp2.txt 12 > nul

  if %layervar% equ 0 (
    type temp2.txt >> !newfilename!
  ) else (
    type temp2.txt >> !filename!!layernum!.srt
  )
  )
 )
)

rem pause

 )
)

rem Attach BOM
if %bomvar% equ 1 (
 if %layervar% equ 0 (
   copy /B /Y bom.txt newfile_bom.txt > nul
   type !newfilename! >> newfile_bom.txt
   del /q !newfilename!
   ren newfile_bom.txt !newfilename!
   if exist "%~dp0nkf32.exe" (
     %~dp0nkf32.exe -W16Lw8 !newfilename! > !newfilename!_UTF8.srt
    )
  ) else (
    for %%n in ( !layernumlist! ) do (
     set lnum=%%n
     set filelayernum=!filename!!lnum!.srt
     copy /B /Y bom.txt newfile_bom.txt > nul
     type !filelayernum! >> newfile_bom.txt
     del /q !filelayernum!
     ren newfile_bom.txt !filelayernum!
     if exist "%~dp0nkf32.exe" (
       %~dp0nkf32.exe -W16Lw8 !filelayernum! > !filelayernum!_UTF8.srt
      )
    )
  )
)

rem No BOM
if %bomvar% equ 0 (
 if %layervar% equ 0 (
   if exist "%~dp0nkf32.exe" (
     %~dp0nkf32.exe -W16Lw !newfilename! > !newfilename!_UTF8N.srt
    )
  ) else (
    for %%n in ( !layernumlist! ) do (
     set lnum=%%n
     set filelayernum=!filename!!lnum!.srt
     if exist "%~dp0nkf32.exe" (
       %~dp0nkf32.exe -W16Lw !filelayernum! > !filelayernum!_UTF8N.srt
      )
    )
  )
)

rem Delete generated files
if exist "bom.txt" del /q "bom.txt"
if exist "temp.txt" del /q "temp.txt"
if exist "temp2.txt" del /q "temp2.txt"

echo;
echo Done
  set /a ff=%ratenum%/%scalenum%
  set /a ffccn=%ratenum%*1000/%scalenum%
  set ffcc=%ffccn:~-3%
echo [ rate=%ratenum% scale=%scalenum% ] %ff%.%ffcc%fps
echo If fps is different please set with Aviutl
echo;
pause

endlocal
exit /b
